;****************************************************************************
;*
;*	conditional breakpoint - created 1997 by future vision
;*
;*	default internal hotkey <ctrl><b>
;*	inside debugger <shift><b> for breakpoint at current address
;*
;****************************************************************************

.386

window_line	EQU	30
window_size	EQU	10

reg_line	EQU	8
reg_size	EQU	38

reg_pos		EQU	reg_line*160

window_pos	EQU	window_line*160
skip_start	EQU	35-window_line
skip_end	EQU	35-(window_line+window_size)
skip_data	EQU	skip_start*100h+skip_end

set_color	MACRO	background,foreground
		mov		color,(background)*16+foreground
		ENDM

Black		EQU	0
Blue		EQU	1
Green		EQU	2
Cyan		EQU	3
Red		EQU	4
Magenta 	EQU	5
Brown		EQU	6
LightGray	EQU	7

DarkGray	EQU	8
LightBlue	EQU	9
LightGreen	EQU	10
LightCyan	EQU	11
LightRed	EQU	12
LightMagenta	EQU	13
Yellow		EQU	14
White		EQU	15

main_seg		SEGMENT	USE16
	ASSUME	CS:main_seg
	ASSUME	DS:main_seg
	ORG	100h

com_entry:	jmp	start_up
	ORG	103h
		DB	'UILM'			;sign
		DW	offset low_mem_end-100h	;low memory size
		DD	0			;no xms
		DD	0
		DW	111010111111b
; 			   ^8  ^4  ^0
		DB	0
		DW	3002h			;<ctrl><b>			;no def external hotkey
		DW	0
		DB	'Cond brkpnt',0		;name
;****************************************************************************
start_up		PROC	NEAR
	LOCALS
		push		si
		push		ds
		mov		ah,0
		int		32h
		pop		es
		pop		si
		push		cs
		pop		ds
		cmp		ax,'IS'
		jne	dos_call
		test		cl,100b		;uilm execution
		jz	dos_call
		shr		cl,3
		and		cl,111b
		cmp		cl,101b		;termin call before unloading
		je	uninstall
		cmp		cl,100b		;start up call after loaded
		je	install
		cmp		cl,011b
		jne	@@auto_execution
;internal_hk
		call	part_one
		jc	@@return
		call	part_two
@@return:	xor		al,al
		retf
@@auto_execution:	
	;check condition
		mov		bx,offset reg_offs
		mov		cx,4*3+8*2
		mov		edx,reg_condition
@@check_condition:
		ror		edx,1
		jnc	@@no_condition
		push		cx
		movzx		cx,[bx+rs_size]
		movzx		si,[bx+rs_offs]
		les		di,register_pos
		add		di,si
		add		si,offset reg_data-8
		rep cmpsb
		pop		cx
		jne	@@bp_again		
@@no_condition:	add		bx,2
		loop	@@check_condition
		
		dec		bp_count
		js	@@del_bp
@@bp_again:	call	set_bp
		
		mov		al,21h
		retf
@@del_bp:	mov		bp_type,0
		call	set_bp
		xor		al,al
		retf
		
;hotkey_call
start_up		ENDP

handler			PROC	FAR
	LOCALS
	;>bl  current line number in debugger
		push		cs		;load data segment
		pop		ds
		cmp		al,1
		jne	@@no_remove
;remove an older handler
		cmp		[old_handler],ebx
		jne	@@jump
		mov		[old_handler],ecx
		retf
@@jump:		jmp	dword ptr [old_handler]
;****************************************************************************
@@no_remove:	cmp		[old_handler],0	;no more handler
		jne	@@old_handler
		mov		bx,-1
		call	disassemble
		mov		ah,0
		int		16h		;return scan code
		jmp	@@check_hotkey
@@old_handler:	call	dword ptr [old_handler]
@@check_hotkey:	cmp		ax,3042h	;pop up hotkey <shift><b>
		je	@@hotkey
		retf
;****************************************************************************
@@hotkey:	mov		bx,skip_data
		call	disassemble
	;>esi linear address
	;>dx  base segment
		mov		bp_lin,esi
		mov		bp_seg,dx
		push		dx
		push		esi
		mov		bp_data,1
		call	window
		mov		di,window_pos+2*160+8
		mov		si,offset $exec
		call	write_string
		call	set_cursor
		mov		ah,2fh
		pop		esi
		pop		dx
		int		32h

		call	part_two
		mov		al,'!'			;return to program
		jnc	@@full_exit
		mov		bx,-1			;disassemble all
		call	disassemble
		xor		ax,ax			;continue
@@full_exit:	retf
handler			ENDP

set_cursor		PROC	NEAR
		lea		bx,[di+2]
set_cursor_:	mov		ah,21h			;cursor pos
		int		32h
		ret
set_cursor		ENDP
;****************************************************************************
;select breakpoint type and size
part_one		PROC	NEAR
	LOCALS
		push		bp
		mov		bp,sp
		call	window
@@draw_loop:	mov		di,window_pos+2*160+2*12
		mov		si,offset $types
		mov		cl,current
		xor		al,al

@@next_type:	push		di
		set_color	blue,white
		cmp		al,cl
		jne	@@not_this
		mov		dx,si
		set_color	magenta,white
@@not_this:	call	write_string
		pop		di
		add		di,80
		inc		al
		cmp		al,0ah
		jb	@@next_type
		mov		ah,0
		int		16h
		cmp		ah,72		;up
		jne	@@no_up
		sub		cl,2
@@no_up:	cmp		ah,80		;down
		jne	@@no_down
		add		cl,2
@@no_down:	cmp		ah,75		;left
		jne	@@no_left
		dec		cl
@@no_left:	cmp		ah,77		;right
		jne	@@no_right
		inc		cl
@@no_right:	or		cl,cl
		jns	@@no_signed
		add		cl,10
@@no_signed:	cmp		cl,9
		jbe	@@no_above
		sub		cl,10
@@no_above:	mov		current,cl
		cmp		al,1bh		;esc
		jne	@@no_esc
@@abort:	leave
		stc
		ret
@@no_esc:	cmp		al,0dh		;cr
		jne	@@draw_loop
		call	window
		mov		si,dx
		mov		di,window_pos+2*160+8
		call	write_string
		cmp		current,0
		je	@@set
		
		mov		bx,window_pos+3*160+8
		call	set_cursor_
		mov		ah,2eh
		int		32h
		jc	@@abort
		push		dx
		push		esi
		mov		ah,2fh
		int		32h
		mov		al,current
		cmp		al,6
		je	@@need_size
		cmp		al,4
		jae	@@set_size
@@need_size:	mov		di,window_pos+5*160+8
		mov		si,offset $size
		call	write_string
@@size_loop:	mov		ah,0
		int		16h
		cmp		al,1bh
		je	@@abort
		xor		ah,ah
		cmp		al,'b'
		je	@@set_size
		inc		ah
		cmp		al,'w'
		je	@@set_size
		cmp		al,'d'
		jne	@@size_loop
		add		ah,2
@@set_size:;ah	size
		push		ax
		
		cmp		current,7
		jb	@@no_exact
		mov		si,offset $value
		mov		di,window_pos+6*160+8
		call	write_string
		call	set_cursor
		mov		ah,25h
		xor		ebx,ebx
		dec		bl
		int		32h
		jc	@@abort
		mov		bp_comp,bl
@@no_exact:	pop		ax
		mov		bp_size,ah
		pop		bp_lin
		pop		bp_seg		
		
@@set:		mov		al,current
		mov		bp_type,al
		leave
		clc
		ret
part_one		ENDP
;***************************************************************************
;debugger call and conditional breakpoints
part_two		PROC	NEAR
	LOCALS
		cmp		bp_type,0
		je	set_bp
		push		bp
		mov		bp,sp
		mov		di,window_pos+7*160+8
		mov		si,offset $skip
		call	write_string
		call	set_cursor
		mov		ah,25h			;skipping
		mov		ebx,-1 shr 1
		int		32h
		jnc	@@continue
@@abort:	stc
		leave
		ret
@@continue:	push		ebx
		mov		di,window_pos+8*160+8
		mov		si,offset $register
		call	write_string
		mov		ah,0
		int		16h
		cmp		al,1bh
		je	@@abort
		mov		reg_condition,0
		cmp		al,'r'			;register condition?
		jne	@@no_register
@@condition_redraw:
		call	reg_window
@@condition_loop:
		mov		di,reg_pos+3*160+8
		mov		si,offset $registers
		mov		bx,offset reg_offs
		mov		edx,reg_condition
		xor		cx,cx
@@write_first:	call	write_first			;hiword hibyte lobyte
		cmp		cl,12
		jb	@@write_first
		
@@write_second:	call	write_second			;hiword loword
		cmp		cl,28
		jb	@@write_second
		mov		ah,0
		int		16h
		
		mov		cl,cur_reg
		cmp		ah,72		;up
		jne	@@no_up
		sub		cl,3
		cmp		cl,11
		jb	@@no_more_up
		inc		cl
@@no_more_up:
@@no_up:	cmp		ah,80		;down
		jne	@@no_down
		add		cl,3
		cmp		cl,14
		jb	@@no_more_down
		dec		cl
@@no_more_down:
@@no_down:	cmp		ah,75		;left
		jne	@@no_left
		dec		cl
@@no_left:	cmp		ah,77		;right
		jne	@@no_right
		inc		cl
@@no_right:	or		cl,cl
		jns	@@not_signed
		xor		cl,cl
@@not_signed:	cmp		cl,27
		jbe	@@not_above
		mov		cl,27
@@not_above:	mov		cur_reg,cl
		cmp		al,0dh		;cr
		jne	@@no_cr
		mov		ah,21h
		mov		bx,reg_pos+1*160+8
		int		32h
		movzx		esi,cl
		movzx		cx,[esi*2+reg_offs+rs_size]
		movzx		di,[esi*2+reg_offs+rs_offs]
		btr		reg_condition,esi
		xor		ebx,ebx
		dec		bl
		dec		cl
		jz	@@size_set
		dec		bh
@@size_set:	mov		ah,25h
		int		32h
		jc	@@condition_redraw
		bts		reg_condition,esi
		mov		ax,bx
		push		ds
		pop		es
		add		di,offset reg_data-8
		stosb
		jcxz	@@byte_only
		mov		es:[di],ah
@@byte_only:
		
		jmp	@@condition_redraw
@@no_cr:	cmp		al,1bh		;esc
		jne	@@condition_loop
		
@@no_register:	pop		bp_count
		leave
set_bp:		mov		ah,09h		;set brkpnt
		mov		cl,3
		mov		esi,bp_lin
		mov		dx,bp_seg
		mov		bx,bp_data
		mov		al,bp_comp
		int		32h
		clc
		ret
part_two		ENDP
;****************************************************************************
write_first		PROC	NEAR
		push		di
		call	write_reg
		add		di,4
		call	write_reg
		add		di,2
		call	write_reg
		pop		di
		add		di,160*3
		ret
write_first		ENDP
write_second		PROC	NEAR
		push		di
		call	write_reg
		add		di,4
		call	write_reg
		pop		di
		add		di,160*3
		ret
write_second		ENDP
write_reg		PROC	NEAR
	LOCALS
		set_color	blue,yellow
		cmp		cl,cur_reg
		jne	@@not_cur_reg
		set_color	magenta,yellow
@@not_cur_reg:	push		cx

		push		di
		push		bx
		add		di,160
		ror		edx,1
		jc	@@condition
		mov		cl,[bx+rs_size]
		shl		cl,1
		mov		al,'x'
@@write_x:	call	write_char
		loop	@@write_x
		jmp	@@no_condition
@@condition:	push		bx
		mov		ah,23h			;output format
		mov		bl,[bx+rs_size]
		shl		bl,1
		mov		bh,10h
		int		32h
		mov		ah,21h			;cursor_pos
		mov		bx,di
		int		32h
		pop		bx
		mov		ah,24h
		movzx		bx,[bx+rs_offs]
		mov		ebx,[bx+reg_data-8]
		int		32h
@@no_condition:	pop		bx
		add		bx,2
		pop		di
		
		mov		cl,3
@@reg_loop:	lodsb
		call	write_char
		loop	@@reg_loop
		pop		cx
		inc		cl
		ret
write_reg		ENDP
;****************************************************************************
window			PROC	NEAR
	LOCALS
		mov		cx,window_size
		mov		di,window_pos
		mov		si,offset $win_name
		jmp	draw_win
window			ENDP
reg_window		PROC	NEAR
		mov		cx,reg_size
		mov		di,reg_pos
		mov		si,offset $reg_name
;		jmp	draw_win
reg_window		ENDP
		
draw_win		PROC	NEAR
	LOCALS
		mov		ah,20h			;text color
		mov		bl,blue*10h+yellow
		int		32h
		push		di
		set_color	blue,white
		mov		al,''
		call	write_char
		mov		al,''
		call	write_line
		mov		al,''
		call	write_char
@@win_loop:	mov		al,''
		call	write_char
		mov		al,' '
		call	write_line
		mov		al,''
		call	write_char
		loop	@@win_loop
		mov		al,''
		call	write_char
		mov		al,''
		call	write_line
		mov		al,''
		call	write_char
		pop		di
		add		di,4
		set_color	blue,lightgray
		call	write_string
		set_color	blue,yellow
		ret
draw_win		ENDP
;****************************************************************************
write_char		PROC	NEAR
		push		ax
		push		es
		mov		ah,color
		push		0b800h
		pop		es
		stosw
		pop		es
		pop		ax
		ret
write_char		ENDP
write_line		PROC	NEAR
	LOCALS
		push		cx
		mov		cx,78
@@line_loop:	call	write_char
		loop	@@line_loop
		pop		cx
		ret
write_line		ENDP
write_string		PROC	NEAR
	LOCALS
		push		ax
@@loop_string:	lodsb
		or		al,al
		jz	@@end_string
		call	write_char
		jmp	@@loop_string
@@end_string:	pop		ax
		ret
write_string		ENDP
;****************************************************************************

reg_condition	DD	0

current		DB	0
$types		DB	'Inactive ',0
		DB	'Execution',0
		DB	'Read     ',0
		DB	'Write    ',0
		DB	'Increase ',0
		DB	'Decrease ',0
		DB	'ReadWrite',0
		DB	'Exact    ',0
		DB	'Below    ',0
		DB	'Above    ',0
$size		DB	'ByteWordDword',0
$value		DB	'Value',0
color		DB	blue*10h+yellow
skip_line	DW	1234h

bp_lin		DD	?
bp_seg		DW	?
bp_data		LABEL	WORD
bp_type		DB	0
bp_size		DB	?
bp_comp		DB	?
bp_count	DD	?

$exec		DB	'one byte execution breakpoint at',0
$skip		DB	'skip breakpoint',0
$register	DB	'press ''R'' if register conditions',0
$win_name	DB	' Conditional Breakpoint ',0
$reg_name	DB	' Register Conditions ',0
$registers	DB	'EAXAH AL '
		DB	'EBXBH BL '
		DB	'ECXCH CL '
		DB	'EDXDH DL '
		DB	'ESISI '
		DB	'EDIDI '
		DB	'ESPSP '
		DB	'EBPBP '
		DB	'EIPIP '
		DB	'CS DS ES FS GS SS ',0
this_handler	DD	?	;seg:offs of this handler
old_handler	DD	?	;seg:offs of previous handler

register_pos	LABEL	DWORD
register_ofs	DW	?
register_seg	DW	?

cur_reg		DB	0

reg_data	DD	4+2+3+6 DUP(0)

reg_struc		STRUC
rs_offs		DB	?
rs_size		DB	?
reg_struc		ENDS

reg_offs	reg_struc	<0ah,2>	;eax hw
		reg_struc	<09h,1>	;ah
		reg_struc	<08h,1>	;al
		reg_struc	<0eh,2>	;ebx hw
		reg_struc	<0dh,1>	;bh
		reg_struc	<0ch,1>	;bl
		reg_struc	<12h,2>	;ecx hw
		reg_struc	<11h,1>	;ch
		reg_struc	<10h,1>	;cl
		reg_struc	<16h,2>	;edx hw
		reg_struc	<15h,1>	;dh
		reg_struc	<14h,1>	;dl
		reg_struc	<1ah,2>	;esi hw
		reg_struc	<18h,2>	;si
		reg_struc	<1eh,2>	;edi hw
		reg_struc	<1ch,2>	;di
		reg_struc	<3ah,2>	;esp hw
		reg_struc	<38h,2>	;sp
		reg_struc	<3eh,2>	;ebp hw
		reg_struc	<3ch,2>	;bp
		reg_struc	<42h,2>	;eip hw
		reg_struc	<40h,2>	;ip
		reg_struc	<20h,2>	;cs
		reg_struc	<24h,2>	;ds
		reg_struc	<28h,2>	;es
		reg_struc	<2ch,2>	;fs
		reg_struc	<30h,2>	;gs
		reg_struc	<34h,2>	;ss

;****************************************************************************
disassemble		PROC	NEAR
;disassemble code skipping lines between al and ah
;return	esi	lin addr of cur line
;	bl	cur line number in debugger
		push		ax
		cmp		bx,[skip_line]
		setne		cl			;1 if different lines
		mov		[skip_line],bx
		mov		ax,1502h		;disassemble
		int		32h
		pop		ax
		ret
disassemble		ENDP
;****************************************************************************
uninstall		PROC	NEAR
		mov		ebx,[this_handler]	;remove handler
		mov		ecx,[old_handler]
		mov		ax,1501h
		int		32h
		xor		al,al
		retf
uninstall		ENDP
install			PROC	NEAR
	LOCALS
		mov		ax,es:[si]		;save buffer addr
		mov		word ptr [register_ofs],ax
		mov		word ptr [register_seg],es

		push		cs			;calc handler address
		push		offset handler
		pop		ebx
		mov		[this_handler],ebx
		mov		ax,1500h		;add to chain
		int		32h
		mov		[old_handler],ebx	;save prev handler

		mov		ah,0ch
		mov		bx,cs
		int		32h
		mov		ah,0bh
		mov		al,cl
		int		32h
		or		al,80h
		mov		cl,7
		int		32h

		xor		al,al
		retf
install			ENDP
low_mem_end		LABEL	WORD
;****************************************************************************
dos_call		PROC	NEAR
		mov		dx,offset $no_dos
		mov		ah,9h
		int		21h
		mov		ax,4c00h
		int		21h
dos_call		ENDP
$no_dos		DB	'INTRUDER, conditional breakpoint uilm by FUTURE VISION',13,10
		DB	'...this is an user interface loadable module and cannot be executed by dos',13,10,'$'
main_seg		ENDS
			END	com_entry
